function N = compute_normals(S,open)
% normals for a closed (or open!) curve

if nargin<2
    open = false;
end

X = S([end,1:end,1],:); % extended S

dX = X(1:end-1,:)-X(2:end,:); % dX
Ne = [dX(:,2),-dX(:,1)]; % edge normals orthogonal to dX
de = sum(Ne.^2,2).^0.5; % for normalization
nonzero = de~=0;
Ne(nonzero,:) = Ne(nonzero,:)./de(nonzero,[1 1]); % edge normals
N = 0.5*(Ne(1:end-1,:)+Ne(2:end,:)); % vertices normals
d = sum(N.^2,2).^0.5; % for normalization
nonzero = d~=0;
N(nonzero,:) = N(nonzero,:)./d(nonzero,[1 1]);

if open
    N(1,:) = Ne(2,:);
    N(end,:) = Ne(end-1,:);
end