function cost = smoothsurface_cost(V,mu,std,s1,s2)
% The code is modifed by Behnaz Pirzamanbein, bepi@dtu.dk last version 2020.08.04
% abda@dtu.dk

if nargin == 1
    mu = 23000;
    std = 4000;
    s1 = 5;
    s2 = 1.5;
elseif nargin == 3
    s1 = 5;
    s2 = 1.5;    
end

V_exp = 1/(std*sqrt(2*pi))*exp(-(V-mu).^2/(2*std^2));
V_exp = V_exp/(max(V_exp(:)));
g = get_gauss(s1);
[~,dg] = get_gauss(s2);
cost = imfilter(imfilter(V_exp, dg','replicate'),g,'replicate');

cost = (cost-min(cost(:)))/(max(cost(:))-min(cost(:)));

function [g,dg] = get_gauss(s)

x = -ceil(3*s):ceil(3*s);
g = exp(-x.^2/(2*s*s));
g = g/sum(g);
dg = -x/(s^2).*g;
%ddg = -g/(s^2) - x/(s^2).*dg;