clear all

Lx = 2;
Ly = 1.3;
Lz = 0.5;

nx = 2;%10
ny = 3;%7
nz = 4;%5

cnt = 1;
for i=1:nx
    for j=1:ny
        for k=1:nz
            nodes(cnt,:) = [cnt i*Lx/nx j*Ly/ny k*Lz/nz];
            cnt = cnt + 1;
        end
    end
end

number_of_nodes = cnt-1;

clf,plot3(nodes(:,2),nodes(:,3),nodes(:,4),'.')

elements = [];
cnt = 1;
for i=1:nx-1
    for j=1:ny-1
        for k=1:nz-1
            x0 = i*Lx/nx;
            y0 = j*Ly/ny;
            z0 = k*Lz/nz;
            x1 = (i+1)*Lx/nx;
            y1 = (j+1)*Ly/ny;
            z1 = (k+1)*Lz/nz;
            
            dist_to_nodes = ((nodes(:,2)-x0).^2+(nodes(:,3)-y0).^2+(nodes(:,4)-z0).^2);
            [minval,minidx] = min(dist_to_nodes);
            corner(1) = minidx;
            dist_to_nodes = ((nodes(:,2)-x1).^2+(nodes(:,3)-y0).^2+(nodes(:,4)-z0).^2);
            [minval,minidx] = min(dist_to_nodes);
            corner(2) = minidx;
            dist_to_nodes = ((nodes(:,2)-x1).^2+(nodes(:,3)-y1).^2+(nodes(:,4)-z0).^2);
            [minval,minidx] = min(dist_to_nodes);
            corner(3) = minidx;
            dist_to_nodes = ((nodes(:,2)-x0).^2+(nodes(:,3)-y1).^2+(nodes(:,4)-z0).^2);
            [minval,minidx] = min(dist_to_nodes);
            corner(4) = minidx;
            
            dist_to_nodes = ((nodes(:,2)-x0).^2+(nodes(:,3)-y0).^2+(nodes(:,4)-z1).^2);
            [minval,minidx] = min(dist_to_nodes);
            corner(5) = minidx;
            
            dist_to_nodes = ((nodes(:,2)-x1).^2+(nodes(:,3)-y0).^2+(nodes(:,4)-z1).^2);
            [minval,minidx] = min(dist_to_nodes);
            corner(6) = minidx;
            
            dist_to_nodes = ((nodes(:,2)-x1).^2+(nodes(:,3)-y1).^2+(nodes(:,4)-z1).^2);
            [minval,minidx] = min(dist_to_nodes);
            corner(7) = minidx;
            dist_to_nodes = ((nodes(:,2)-x0).^2+(nodes(:,3)-y1).^2+(nodes(:,4)-z1).^2);
            [minval,minidx] = min(dist_to_nodes);
            corner(8) = minidx;
            
            elements(cnt,:)=[cnt corner([1 2 3 4 5 6 7 8   ])];
            cnt=cnt+1;

        end
    end
end

figure,patch('Faces',elements(:,2:end),'Vertices',nodes(:,2:4))
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% fid = fopen('output_mesh_example.inp','w');
% fprintf(fid,'*Part, name=my_mesh \n');
% fprintf(fid,'*Node \n');
% for i=1:size(nodes,1)
%     fprintf(fid,'%d, %f, %f, %f \n',nodes(i,:));
% end
% fprintf(fid,'*Element, type=C3D8R \n');
% for i = 1:size(elements,1)
%     fprintf(fid,'%d, %d, %d, %d, %d, %d, %d, %d, %d \n',elements(i,:));
% end
% 
% fprintf(fid,'*End Part \n');